## ros-one-qb-device-hardware-interface 3.1.2-1jammy.20251023.0154

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2 FATAL_ERROR)
project(qb_device_hardware_interface VERSION 3.1.2 LANGUAGES CXX)

# Dependency Settings
find_package(catkin REQUIRED
  COMPONENTS
    roscpp
    hardware_interface
    joint_limits_interface
    transmission_interface
    control_msgs
    urdf
    qb_device_msgs
    qb_device_srvs
)

include_directories(include
  ${catkin_INCLUDE_DIRS}
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    roscpp
    hardware_interface
    joint_limits_interface
    transmission_interface
    control_msgs
    urdf
    qb_device_msgs
    qb_device_srvs
)

# Exported libraries
add_library(${PROJECT_NAME}
  src/qb_device_hardware_interface.cpp
)

target_link_libraries(${PROJECT_NAME}
  PUBLIC
    ${catkin_LIBRARIES}
)

add_dependencies(${PROJECT_NAME}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

# Installation
install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION
    ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

# Tests
if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

#TODO: catkin_add_gmock: http://docs.ros.org/melodic/api/catkin/html/dev_guide/generated_cmake_api.html#catkin-add-gmock

#  # explicit gmock build FIXME: outside sourcing
#  include_directories(/usr/include/gmock /usr/src/gmock)
#  find_library(GMOCK_LIBRARIES libgmock)
#  if(NOT GMOCK_LIBRARIES)
#    add_library(libgmock /usr/src/gmock/src/gmock-all.cc)
#  endif()

  catkin_add_gtest(${PROJECT_NAME}_unit_tests
    src/test/unit_tests.cpp
  )

  target_link_libraries(${PROJECT_NAME}_unit_tests
#    libgmock
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
  )

  if (CMAKE_VERSION VERSION_LESS "3.1")
    target_compile_options(${PROJECT_NAME}_unit_tests
      PUBLIC
        "-std=c++14"
    )
  else ()
    set_property(
      TARGET
        ${PROJECT_NAME}_unit_tests
      PROPERTY CXX_STANDARD 14
    )

    set_property(
      TARGET
        ${PROJECT_NAME}_unit_tests
      PROPERTY CXX_STANDARD_REQUIRED ON
    )
  endif ()
endif()

=== debian/changelog ===
ros-one-qb-device-hardware-interface (3.1.2-1jammy.20251023.0154) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Thu, 23 Oct 2025 01:54:52 +0000

ros-one-qb-device-hardware-interface (3.1.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.1.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.1.0-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Jul 2023 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.6-0jammy) jammy; urgency=high

  * FEAT: Added compatibility with new FW version of SHR
  * MINOR FIX: Changed the name of the package maintainer

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Apr 2023 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.5-0jammy) jammy; urgency=high

  * MINOR FIX: Changed cmake version required in all packages (current version 3.0.2).
  * FIX: Added control_msgs dependecy in qb_device_hardware_interface pkg. This cause error during release phase.
  * Bug fixed when executing the waypoint movement and different controller with different number of controller joints are loaded.

 -- qb Support Team <support@qbrobotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.4-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 18 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.3-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 15 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Thu, 07 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 06 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.0-0jammy) jammy; urgency=high

  * New API migration. qb_device_driver class is no longer required.

 -- qb Support Team <support@qbrobotics.com>  Tue, 05 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.4-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.3-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.0-0jammy) jammy; urgency=high

  * BUG FIX when a generic qbrobotics device roslaunch is grouped in a namespace

 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.2.1-0jammy) jammy; urgency=high

  * Fix qbhand movement at startup
  * Fix qb SoftHands startup

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.2.0-0jammy) jammy; urgency=high

  * Replaced error stream with throttle
  * Add controller startup sync to avoid hardcoded wait
  * Refactor control structures initialization
  * Pass command_old value in PositionJointSaturationHandle constructor
  * Set out-of-range warning with _TRHOTTLE mode
  * Add methods to retrieve actual device references
  * Set a better name for fake joint simulation variables
  * Added the control mode switch service. Added a parameter to choose to use .yaml limits or firmware ones.
  * Update license

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.1.1-0jammy) jammy; urgency=high

  * Fix initial command and velocity limit for qbmoves

 -- qb Support Team <support@qbrobotics.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.1.0-0jammy) jammy; urgency=high

  * Add comments for future changes
  * Add a simulator mode to debug joint trajectories
  * Fix minor style issues
  * Fix position limits initialization
  * Fix minor style issues

 -- qb Support Team <support@qbrobotics.com>  Tue, 28 May 2019 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.3-0jammy) jammy; urgency=high

  * Update license agreement copyright

 -- qb Support Team <support@qbrobotics.com>  Thu, 09 Aug 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Tue, 07 Aug 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 01 Jun 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.0-0jammy) jammy; urgency=high

  * Add device configuration to the state topic info
  * Fix recovery on service server fault
  * Refactor node registration
  * Fix accidental repetitions with namespace prefix
  * Refactor initialization by extending the base init
  * Add method to get currents and positions together
  * Fix repetitions reliablity check
  * Add a blocking setCommands method
  * Refactor launch files and fix controllers spawner
  * Fix minors
  * Let the user decide whether to read/write or not
  * Refactor node registration
  * Add repetitions while reading from serial

 -- qb Support Team <support@qbrobotics.com>  Wed, 30 May 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (1.2.2-0jammy) jammy; urgency=high

  * Fix possible fault on registration
  * Refactor service clients management

 -- qb Support Team <support@qbrobotics.com>  Thu, 30 Nov 2017 00:00:00 -0000



=== debian/control ===
Source: ros-one-qb-device-hardware-interface
Section: misc
Priority: optional
Maintainer: qb Support Team <support@qbrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-control-msgs, ros-one-hardware-interface, ros-one-joint-limits-interface, ros-one-qb-device-msgs, ros-one-qb-device-srvs, ros-one-roscpp, ros-one-transmission-interface, ros-one-urdf
Homepage: http://wiki.ros.org/qb_device_hardware_interface
Standards-Version: 3.9.2

Package: ros-one-qb-device-hardware-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-control-msgs, ros-one-hardware-interface, ros-one-joint-limits-interface, ros-one-qb-device-msgs, ros-one-qb-device-srvs, ros-one-roscpp, ros-one-transmission-interface, ros-one-urdf
Description: This package contains a device-independent hardware interface for qbrobotics® devices.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-qb-device-hardware-interface//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-qb-device-hardware-interface 3.1.2-1jammy.20260220.2243

=== debian/changelog ===
ros-one-qb-device-hardware-interface (3.1.2-1jammy.20260220.2243) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Fri, 20 Feb 2026 22:43:07 +0000

## ros-one-qb-device-hardware-interface 3.1.2-1noble.20251023.0153

=== debian/changelog ===
ros-one-qb-device-hardware-interface (3.1.2-1noble.20251023.0153) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Thu, 23 Oct 2025 01:53:17 +0000

ros-one-qb-device-hardware-interface (3.1.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.1.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.1.0-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Jul 2023 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.6-0noble) noble; urgency=high

  * FEAT: Added compatibility with new FW version of SHR
  * MINOR FIX: Changed the name of the package maintainer

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Apr 2023 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.5-0noble) noble; urgency=high

  * MINOR FIX: Changed cmake version required in all packages (current version 3.0.2).
  * FIX: Added control_msgs dependecy in qb_device_hardware_interface pkg. This cause error during release phase.
  * Bug fixed when executing the waypoint movement and different controller with different number of controller joints are loaded.

 -- qb Support Team <support@qbrobotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.4-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 18 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.3-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 15 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Thu, 07 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 06 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (3.0.0-0noble) noble; urgency=high

  * New API migration. qb_device_driver class is no longer required.

 -- qb Support Team <support@qbrobotics.com>  Tue, 05 Jul 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.4-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.3-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.3.0-0noble) noble; urgency=high

  * BUG FIX when a generic qbrobotics device roslaunch is grouped in a namespace

 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.2.1-0noble) noble; urgency=high

  * Fix qbhand movement at startup
  * Fix qb SoftHands startup

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.2.0-0noble) noble; urgency=high

  * Replaced error stream with throttle
  * Add controller startup sync to avoid hardcoded wait
  * Refactor control structures initialization
  * Pass command_old value in PositionJointSaturationHandle constructor
  * Set out-of-range warning with _TRHOTTLE mode
  * Add methods to retrieve actual device references
  * Set a better name for fake joint simulation variables
  * Added the control mode switch service. Added a parameter to choose to use .yaml limits or firmware ones.
  * Update license

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.1.1-0noble) noble; urgency=high

  * Fix initial command and velocity limit for qbmoves

 -- qb Support Team <support@qbrobotics.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.1.0-0noble) noble; urgency=high

  * Add comments for future changes
  * Add a simulator mode to debug joint trajectories
  * Fix minor style issues
  * Fix position limits initialization
  * Fix minor style issues

 -- qb Support Team <support@qbrobotics.com>  Tue, 28 May 2019 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.3-0noble) noble; urgency=high

  * Update license agreement copyright

 -- qb Support Team <support@qbrobotics.com>  Thu, 09 Aug 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Tue, 07 Aug 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 01 Jun 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (2.0.0-0noble) noble; urgency=high

  * Add device configuration to the state topic info
  * Fix recovery on service server fault
  * Refactor node registration
  * Fix accidental repetitions with namespace prefix
  * Refactor initialization by extending the base init
  * Add method to get currents and positions together
  * Fix repetitions reliablity check
  * Add a blocking setCommands method
  * Refactor launch files and fix controllers spawner
  * Fix minors
  * Let the user decide whether to read/write or not
  * Refactor node registration
  * Add repetitions while reading from serial

 -- qb Support Team <support@qbrobotics.com>  Wed, 30 May 2018 00:00:00 -0000

ros-one-qb-device-hardware-interface (1.2.2-0noble) noble; urgency=high

  * Fix possible fault on registration
  * Refactor service clients management

 -- qb Support Team <support@qbrobotics.com>  Thu, 30 Nov 2017 00:00:00 -0000



## ros-one-qb-device-hardware-interface 3.1.2-1noble.20260220.2257

=== debian/changelog ===
ros-one-qb-device-hardware-interface (3.1.2-1noble.20260220.2257) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Fri, 20 Feb 2026 22:57:54 +0000
